import { File } from "@nativescript/core";
export declare abstract class UploadCommon {
    static defaultOptions: UploadOptions;
    options: UploadOptions;
    file: File;
    url: string | null;
    constructor(file: File, options: UploadOptions);
    abstract start(): void;
    abstract abort(): Promise<void>;
}
export interface UploadOptions {
    endpoint?: string | null;
    headers?: {
        [key: string]: string;
    };
    metadata?: {
        [key: string]: string;
    };
    onProgress?: ((bytesSent: number, bytesTotal: number) => void) | null;
    onChunkComplete?: ((chunkSize: number, bytesAccepted: number, bytesTotal: number) => void) | null;
    onSuccess?: (() => void) | null;
    onError?: ((error: Error) => void) | null;
}
